//draw the astronomer and his telescope
//  from "Night Vision" by Darren Izzard

#declare IMPORT_SPATCH=1

#include "colors.inc"
#include "textures.inc"
#include "astron.inc"

//object is Astronomer

// for testing
//camera { location <-3,2,-7> look_at <2,0,0>}
//light_source { <-10,15,-15> color White }

#declare AstroSkin=texture{pigment{color Flesh}}

#declare AstroHand=texture {
                           pigment { gradient y
                                     pigment_map {
                                       [0.0 color Flesh]
                                       [1.0 wood
                                            color_map {
                                                      [0.0 color Flesh]
                                                      [1.0 color Gray60]
                                                      }
                                            scale 0.25
                                            ]
                                       }
                                     }
                           }

#declare AstroHair=texture {
         pigment { wood
                   color_map {
                             [0.0 color rgb <0.75,0.2,0>]
                             [0.5 color rgb <0.8,0.1,0>]
                             [1.0 color rgb <0.5,0,0>]
                             }
                   turbulence 0.5
                   scale 0.25
                   }
         normal { bumps
                  scale 0.1
                  }
         }

#declare AstroTele=texture {
         pigment { color rgb <0.7,0.2,0.45>
                   }
         finish {
                specular 0.5
                roughness 0.05
                }
         }

#declare AstroClothing=texture {
         pigment { onion
                   color_map {
                             [0.0 color rgb <0.2,0.5,0.2>]
                             [0.5 color rgb <0.3,0.3,0.3>]
                             [1.0 color rgb <0.2,0.5,0.5>]
                             }
                   scale 0.05
                   }
         normal { granite
                  scale 0.25
                  }
         }

#declare Astronomer=union {
         object {
                AstroLayer1     //cheek/ear
                texture {AstroSkin}
                }
         object {
                AstroLayer2     //hair
                texture {AstroHair}
                }
         object {
                AstroLayer3     //neck
                texture {AstroSkin}
                }
         object {
                AstroLayer4     //torso/arm
                texture {AstroClothing}
                }
         object {
                AstroLayer5     //telescope
                texture {AstroTele}
                }
         object {
                AstroLayer6     //hand
                texture {AstroHand}
                }
         }

//for testing
//object {
//       Astronomer
//       }
